% lab06_ex_fft_length.m
% optimal length for fast FFT computation (using FFTW library)

if(1)
  N=2500;
  a=0; b=0; c=0; d=0; e=0; f=0'
  while(rem(N,2)==0) N=N/2; a=a+1; end, a, 2^a, pause
  while(rem(N,3)==0) N=N/3; b=b+1; end, b, 3^b, pause
  while(rem(N,5)==0) N=N/5; c=c+1; end, c, 5^c, pause
  while(rem(N,7)==0) N=N/7; d=d+1; end, d, 7^d, pause
  while(rem(N,11)==0) N=N/11; e=e+1; end, e, 11^e, pause
  while(rem(N,13)==0) N=N/13; f=f+1; end, f, 13^f, pause
  NN = N * 2^a * 3^b * 5^c * 7^d * 11^e * 13^f, pause
end

a = [ 2, 3, 5, 7, 11, 13 ]; Na=length(a);
p = zeros(1,Na);
%N = prod(a.^2); Ncopy=N; % for test only
N = 5000; Ncopy=N;
for k = 1 : Na
    while(rem(N,a(k))==0) N=N/a(k); p(k)=p(k)+1; end
end
N, p, prod( a .^ p), pause
if( N > 1 )
   Np=12345; Nm=12345;
   i = 1;
   while( Np~=1 & Nm~=1 )
      i, pause
      Np=Ncopy+i;
      Nm=Ncopy-i;
      pp = zeros(1,6); pm = zeros(1,6);
      for k = 1 : Na
          while(rem(Np,a(k))==0) Np=Np/a(k); pp(k)=pp(k)+1; end
      end
      for k = 1 : Na
          while(rem(Nm,a(k))==0) Nm=Nm/a(k); pm(k)=pm(k)+1; end
      end
      i = i+1;
   end
   if(Np==1) N = prod( a .^ pp), end
   if(Nm==1) N = prod( a .^ pm), end 
end
